package cn.com.taiji.service.impl;

import cn.com.taiji.constants.TopicConstants;
import cn.com.taiji.entity.BeidouShipTrackDTO;
import cn.com.taiji.entity.HlxOneLevelTrackDTO;
import cn.com.taiji.entity.Location;
import cn.com.taiji.service.SimulationTrackService;
import cn.com.taiji.utils.LocationUtils;
import cn.hutool.core.date.DateUtil;
import cn.hutool.json.JSONUtil;
import lombok.extern.slf4j.Slf4j;
import org.apache.poi.ss.formula.functions.T;
import org.springframework.kafka.core.KafkaTemplate;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.RequestParam;

import javax.annotation.Resource;
import java.util.HashSet;
import java.util.List;

/**
 * @author chenfangchao
 * @title: SimulationTrackImpl
 * @projectName es-track-analysis
 * @description: TODO
 * @date 2023/2/7 5:16 PM
 */
@Slf4j
@Service
public class SimulationTrackImpl implements SimulationTrackService {


    @Resource
    private KafkaTemplate<String, Object> kafkaTemplate;


    public static void main(String[] args) {
        List<Location> list = LocationUtils.generateLogLat("2023-02-03 00:00:00", "2023-02-03 00:00:50", 109.287806, 19.718716, 101.287806, 19.918716);
    }


    HashSet<Thread> beidouThreads = new HashSet<>();

    private Integer beidouStatus;

    HashSet<Thread> hlxOneLevelTherads = new HashSet<>();

    private Integer hlxOneLevelStatus;


    HashSet<Thread> beidouhlxOneLevelTherads = new HashSet<>();

    private Integer beidouhlxOneLevelStatus;


    @Override
    public void beidouTrack(Integer status) {
        //开始位置 109.67642971192785,18.18460507789732 三亚位置 西州
        //结束位置 109.69596855881268,18.185299250953545 三亚位置 东洲
        //模拟同船的第一个设备
        beidouStatus = status;
        if (0 == beidouStatus) {
            Thread thread = new Thread(() -> {
                while (true) {
                    if (beidouStatus == 1) {
                        Thread.currentThread().interrupt();
                    } else {
                        List<Location> list = LocationUtils.generateLogLat("2023-02-03 00:00:00", "2023-02-03 00:02:10", 109.67642971192785, 18.18460507789732, 109.69596855881268, 18.185299250953545);
                        for (Location location : list) {
                            BeidouShipTrackDTO beidouShipTrackDTO = new BeidouShipTrackDTO();
                            beidouShipTrackDTO.setId("20236688");
                            beidouShipTrackDTO.setCurren_time(DateUtil.now());
                            beidouShipTrackDTO.setTrackId(20236688);
                            beidouShipTrackDTO.setDeviceId(20236688);
                            beidouShipTrackDTO.setSendTime(DateUtil.now());
                            beidouShipTrackDTO.setLocationTime(DateUtil.now());
                            beidouShipTrackDTO.setShipName("20236688测试船舶");
                            beidouShipTrackDTO.setReceiveTime(DateUtil.now());
                            beidouShipTrackDTO.setLongitude(location.getLog());
                            beidouShipTrackDTO.setLatitude(location.getLat());
                            String data = JSONUtil.toJsonStr(beidouShipTrackDTO);
                            try {
                                Thread.sleep(1000);
                                kafkaTemplate.send(TopicConstants.BEIDOU_TOPIC, data);
                                log.info(DateUtil.now() + "模拟北斗船舶:20236688测试船舶,终端号为20236688完成");
                            } catch (InterruptedException e) {
                                Thread.currentThread().interrupt();
                                e.printStackTrace();
                            }
                        }
                    }
                }
            });
            Thread thread1 = new Thread(() -> {
                while (true) {
                    if (beidouStatus == 1) {
                        Thread.currentThread().interrupt();
                    } else {
                        /**
                         * 开始位置 109.67638187069215,18.184651060263896 三亚位置 西州偏北一点
                         * 结束位置 109.69603272744908,18.18548237188056 三亚位置 东洲偏北一点
                         */
                        //模拟同船的第二个设备
                        List<Location> list1 = LocationUtils.generateLogLat("2023-02-03 00:00:00", "2023-02-03 00:02:10", 109.67638187069215, 18.184651060263896, 109.69603272744908, 18.18548237188056);
                        for (Location location : list1) {
                            BeidouShipTrackDTO beidouShipTrackDTO = new BeidouShipTrackDTO();
                            beidouShipTrackDTO.setId("20236699");
                            beidouShipTrackDTO.setCurren_time(DateUtil.now());
                            beidouShipTrackDTO.setTrackId(20236699);
                            beidouShipTrackDTO.setDeviceId(20236699);
                            beidouShipTrackDTO.setSendTime(DateUtil.now());
                            beidouShipTrackDTO.setLocationTime(DateUtil.now());
                            beidouShipTrackDTO.setShipName("20236688测试船舶");
                            beidouShipTrackDTO.setReceiveTime(DateUtil.now());
                            beidouShipTrackDTO.setLongitude(location.getLog());
                            beidouShipTrackDTO.setLatitude(location.getLat());
                            String data = JSONUtil.toJsonStr(beidouShipTrackDTO);
                            try {
                                Thread.sleep(1000);
                                kafkaTemplate.send(TopicConstants.BEIDOU_TOPIC, data);
                                log.info(DateUtil.now() + "模拟北斗船舶:20236688测试船舶,终端号为20236699完成");
                            } catch (InterruptedException e) {
                                Thread.currentThread().interrupt();
                                e.printStackTrace();
                            }
                        }
                    }
                }
            });
            thread.start();
            thread1.start();
            beidouThreads.add(thread);
            beidouThreads.add(thread1);
        }
        if (1 == beidouStatus) {
            for (Thread item : beidouThreads) {
                item.interrupt();
            }
        }
    }

    @Override
    public void aisTrack(Integer status) {
        //开始位置 109.67642971192785,18.18460507789732
        //结束位置 109.69596855881268,18.185299250953545
        //模拟同船的第一个设备
        hlxOneLevelStatus = status;
        if (hlxOneLevelStatus == 0) {
            Thread thread = new Thread(() -> {
                while (true) {
                    if (hlxOneLevelStatus == 1) {
                        Thread.currentThread().interrupt();
                    } else {
                        List<Location> list = LocationUtils.generateLogLat("2023-02-03 00:00:00", "2023-02-03 00:02:10", 109.67642971192785, 18.18460507789732, 109.69596855881268, 18.185299250953545);
                        for (Location location : list) {
                            HlxOneLevelTrackDTO hlxOneLevelTrack = new HlxOneLevelTrackDTO();
                            hlxOneLevelTrack.setLatitude(location.getLat());
                            hlxOneLevelTrack.setLongitude(location.getLog());
                            hlxOneLevelTrack.setRadarID("20236666");
                            hlxOneLevelTrack.setTargetID("20236666");
                            hlxOneLevelTrack.setTime(DateUtil.now());
                            hlxOneLevelTrack.setVesselName("测试船舶20236666");
                            String data = JSONUtil.toJsonStr(hlxOneLevelTrack);
                            try {
                                Thread.sleep(1000);
                                kafkaTemplate.send(TopicConstants.HLX_ONE_LEVEL, data);
                                log.info(DateUtil.now() + "模拟海兰信一级融合船舶:测试船舶20236666,终端号为20236666完成");
                            } catch (InterruptedException e) {
                                Thread.currentThread().interrupt();
                                e.printStackTrace();
                            }
                        }
                    }
                }
            });
            Thread thread1 = new Thread(() -> {
                while (true) {
                    if (hlxOneLevelStatus == 1) {
                        Thread.currentThread().interrupt();
                    } else {
                        /**
                         * 开始位置 109.67638187069215,18.184651060263896
                         * 结束位置 109.69603272744908,18.18548237188056
                         */
                        //模拟同船的第二个设备
                        List<Location> list1 = LocationUtils.generateLogLat("2023-02-03 00:00:00", "2023-02-03 00:02:10", 109.67638187069215, 18.184651060263896, 109.69603272744908, 18.18548237188056);
                        for (Location location : list1) {
                            HlxOneLevelTrackDTO hlxOneLevelTrack = new HlxOneLevelTrackDTO();
                            hlxOneLevelTrack.setLatitude(location.getLat());
                            hlxOneLevelTrack.setLongitude(location.getLog());
                            hlxOneLevelTrack.setRadarID("20236677");
                            hlxOneLevelTrack.setTargetID("20236677");
                            hlxOneLevelTrack.setTime(DateUtil.now());
                            hlxOneLevelTrack.setVesselName("测试船舶20236666");
                            String data = JSONUtil.toJsonStr(hlxOneLevelTrack);
                            try {
                                Thread.sleep(1000);
                                kafkaTemplate.send(TopicConstants.HLX_ONE_LEVEL, data);
                                log.info(DateUtil.now() + "模拟海兰信一级融合船舶:测试船舶20236666,终端号为20236677完成");
                            } catch (InterruptedException e) {
                                Thread.currentThread().interrupt();
                                e.printStackTrace();
                            }
                        }
                    }
                }
            });
            thread.start();
            thread1.start();
            hlxOneLevelTherads.add(thread);
            hlxOneLevelTherads.add(thread1);
        }

        if (1 == hlxOneLevelStatus) {
            for (Thread item : hlxOneLevelTherads) {
                item.interrupt();
            }
        }
    }

    @Override
    public void beidouaisTrack(Integer status) {
        beidouhlxOneLevelStatus = status;
        if (0 == beidouhlxOneLevelStatus) {
            Thread thread = new Thread(() -> {
                while (true) {
                    if (beidouhlxOneLevelStatus == 1) {
                        Thread.currentThread().interrupt();
                    } else {
                        List<Location> list = LocationUtils.generateLogLat("2023-02-03 00:00:00", "2023-02-03 00:02:10", 109.67642971192785, 18.18460507789732, 109.69596855881268, 18.185299250953545);
                        for (Location location : list) {
                            BeidouShipTrackDTO beidouShipTrackDTO = new BeidouShipTrackDTO();
                            beidouShipTrackDTO.setId("20236688");
                            beidouShipTrackDTO.setCurren_time(DateUtil.now());
                            beidouShipTrackDTO.setTrackId(20236688);
                            beidouShipTrackDTO.setDeviceId(20236688);
                            beidouShipTrackDTO.setSendTime(DateUtil.now());
                            beidouShipTrackDTO.setLocationTime(DateUtil.now());
                            beidouShipTrackDTO.setShipName("20236688测试船舶");
                            beidouShipTrackDTO.setReceiveTime(DateUtil.now());
                            beidouShipTrackDTO.setLongitude(location.getLog());
                            beidouShipTrackDTO.setLatitude(location.getLat());
                            String data = JSONUtil.toJsonStr(beidouShipTrackDTO);
                            try {
                                Thread.sleep(1000);
                                kafkaTemplate.send(TopicConstants.BEIDOU_TOPIC, data);
                                log.info(DateUtil.now() + "模拟北斗船舶:20236688测试船舶,终端号为20236688完成");
                            } catch (InterruptedException e) {
                                Thread.currentThread().interrupt();
                                e.printStackTrace();
                            }
                        }
                    }
                }
            });
            Thread thread1 = new Thread(() -> {
                while (true) {
                    if (beidouhlxOneLevelStatus == 1) {
                        Thread.currentThread().interrupt();
                    } else {
                        List<Location> list1 = LocationUtils.generateLogLat("2023-02-03 00:00:00", "2023-02-03 00:02:10", 109.67642971192785, 18.18460507789732, 109.69596855881268, 18.185299250953545);
                        for (Location location : list1) {
                            HlxOneLevelTrackDTO hlxOneLevelTrack = new HlxOneLevelTrackDTO();
                            hlxOneLevelTrack.setLatitude(location.getLat());
                            hlxOneLevelTrack.setLongitude(location.getLog());
                            hlxOneLevelTrack.setRadarID("20236666");
                            hlxOneLevelTrack.setTargetID("20236666");
                            hlxOneLevelTrack.setTime(DateUtil.now());
                            hlxOneLevelTrack.setVesselName("20236688测试船舶");
                            String data = JSONUtil.toJsonStr(hlxOneLevelTrack);
                            try {
                                Thread.sleep(1000);
                                kafkaTemplate.send(TopicConstants.HLX_ONE_LEVEL, data);
                                log.info(DateUtil.now() + "模拟海兰信一级融合船舶:20236688测试船舶,终端号为20236666完成");
                            } catch (InterruptedException e) {
                                Thread.currentThread().interrupt();
                                e.printStackTrace();
                            }
                        }
                    }
                }
            });
            thread.start();
            thread1.start();
            beidouhlxOneLevelTherads.add(thread);
            beidouhlxOneLevelTherads.add(thread1);
        }
        if (1 == beidouhlxOneLevelStatus) {
            for (Thread item : beidouhlxOneLevelTherads) {
                item.interrupt();
            }
        }
    }

}
